<template>
  <div class="pb-8">
    <h1 class="mb-5">Complete your visit</h1>
    <div class="flex flex-col pt-5 px-4 bg-white rounded-lg mb-8">
      <div class="pb-5 grid grid-cols-2">
        <div>
          <div class="mb-1 text-base">{{ boughtProduct.name }}</div>
          <div class="text-xs text-grey-dark mb-2">
            <p>{{ boughtProduct.supplyDuration }}</p>
            <p>{{ boughtProduct.shipping }}</p>
          </div>
          <div
            v-if="boughtProduct.newPrice"
            class="text-xs text-red"
          >
            You saved ${{ boughtProduct.oldPrice - boughtProduct.newPrice }}
          </div>
        </div>
        <div class="text-right flex flex-col justify-center text-base justify-self-end">
          <template v-if="boughtProduct.price">
            <p>${{ boughtProduct.price }}</p>
          </template>
          <template v-else>
            <p class="text-grey-dark line-through">${{ boughtProduct.oldPrice }}</p>
            <p>${{ boughtProduct.newPrice }}</p>
          </template>
        </div>
      </div>
      <div
        class="flex justify-between items-center border-t border-grey-darker pt-5 pb-4"
        v-for="item in orderedItems"
        :key="item.id"
      >
        <div>{{ item.title }}</div>
        <div class="text-base" v-if="item.newPrice">
          <p class="text-grey-dark line-through">${{ item.oldPrice }}</p>
          <p>${{ item.newPrice }}</p>
        </div>
        <div v-else class="text-base">${{ item.price }}</div>
      </div>
      <div
        class="flex justify-between items-center border-t border-grey-darker pt-5 pb-4"
      >
        <div>
          <div class="mb-1">Doctor Consultation</div>
          <p class="text-xs text-grey-dark">Typically occurs within 4 hours.</p>
        </div>
        <div class="text-base text-right">
          <p class="text-grey-dark line-through">$15</p>
          <p>FREE</p>
        </div>
      </div>
      <div
        class="flex justify-between items-center border-t border-grey-darker pt-5 pb-4"
      >
        <div>2-Day Expedited Shipping</div>
        <div class="text-base text-right">
          <p class="text-grey-dark line-through">$15</p>
          <p>FREE</p>
        </div>
      </div>
      <div
        class="flex justify-between items-center border-t border-grey-darker pt-5 pb-4"
      >
        <div>Due Now</div>
        <div class="text-base">$0</div>
      </div>
    </div>
    <div class="h1 mb-3">Pay with</div>
    <div class="flex justify-between mb-3">
      <div class="text-base">Credit or Debit Card</div>
      <div class="flex space-x-1">
        <img :src="img" alt="" width="36px" v-for="(img, index) in paymentTypes" :key="index">
      </div>
    </div>
    <div class="mb-3">
      <div class="grid grid-cols-payment payment-input bg-white px-5 py-6 rounded-lg border border-grey-darker">
        <img src="@/assets/img/icons/lock.png" alt="" width="16px" class="mr-2">
        <input v-model="selected.cardNumber" type="text" pattern="\d*" maxlength="16" placeholder="Card Number" class="w-full ml-2 bg-transparent">
        <input :value="selected.cardDate" @input="handleDateInput($event.target.value)" type="text" placeholder="MM/YY" class="w-full px-2 bg-transparent">
        <input v-model="selected.cardCCV" type="text" pattern="\d*" maxlength="3" placeholder="CCV" class="w-full bg-transparent">
      </div>
    </div>
    <CommonBtn
      text="Pay $0 Today"
      class="mb-5"
      :disabled="!selected.cardNumber || !selected.cardDate || !selected.cardCCV"
      @click="$emit('nextStage')"
    />
    <div class="space-y-3 text-xs text-black-dark mb-8">
      <p>By clicking PAY $0 TODAY, you agree that: </p>
      <p>{{ getPrescribedText }}</p>
      <p>- You can cancel your plan anytime by logging into your account, calling us at (866) 294-3772 or emailing us at customercare@rexmd.com</p>
      <p>- A valid photo of your US Government issued ID and profile is required after checkout as required by law.</p>
      <p>- If there is an emergency and you are experiencing severe symptoms or bleeding, please call 911 or seek in-person care immediately.</p>
    </div>
    <footer class="flex justify-center items-center">
      <img
        src="@/assets/img/icons/lock.png"
        width="14"
        alt="lock icon"
        class="mr-3"
      >
      <span class="text-xs text-grey-dark">
        256-bit TLS Security
      </span>
    </footer>
  </div>
</template>

<script>
import {answersMixin, productMixin} from "@/utils/mixins";
import CommonBtn from "@/components/common/CommonBtn";
import {constants} from "@/constants";

export default {
  components: {CommonBtn},
  mixins: [answersMixin, productMixin],
  name: "Checkout",
  data() {
    return {
      selected: {
        cardNumber: '',
        cardDate: '',
        cardCCV: '',
      },
      paymentTypes: [
        require('@/assets/img/misc/mastercard.png'),
        require('@/assets/img/misc/visa.png'),
        require('@/assets/img/misc/american_express.png'),
        require('@/assets/img/misc/discover.png'),
      ]
    }
  },
  methods: {
    handleDateInput(val) {
      val = val.replace('/', '').slice(0, 4)
      if (Number(val) === Number.NaN) {
        return
      }

      if (val.length > 2) {
        this.selected.cardDate = `${val.slice(0, 2)}/${val.slice(2, 4)}`
      } else {
        this.selected.cardDate = val.slice(0, 2)
      }
    }
  },
  computed: {
    getPrescribedText() {
      const price = this.boughtProduct.newPrice || this.boughtProduct.price
      const isThreeMonths = this.boughtProduct.supplyDuration === constants.EVERY_3_MONTHS
      const durationText = isThreeMonths ? 'first three months' : 'first month'
      const additionalInfo = isThreeMonths ? 'every 3 months' : 'every month'
      return `- If prescribed ${ this.boughtProduct.name }, you are purchasing a continuous subscription and will be charged $${price} for your ${durationText} and $${price} ${additionalInfo} thereafter until you cancel or your prescription expires.`
    }
  }
}
</script>

<style scoped>
input {
  @apply outline-none;
}
</style>
